#! /usr/bin/perl -w
#
#

my %reg_val;

open REG_FILE, "< rv515.rai";

$num_regs = 0;
while (<REG_FILE>)
{ 
#	print $_;
	if (/primaryRegisterAperture:/)
	{
		@resource = split;

		$reg_name[$num_regs] = $resource[0];
		
		@aperinfo = split(/:/, $resource[1]);
		chop $aperinfo[1];
		
		$reg_num[$num_regs] = hex $aperinfo[1];
		$num_regs++;
	}
}

close REG_FILE;

$count = 0;
while ($count < $num_regs)
{
#print "reg: ", $reg_name[$count], " ", $reg_num[$count], "\n";
	$count++;
}

open IN_FILE, "< $ARGV[0]";

while (<IN_FILE>)
{
	if (/INREG/)
	{
		@tempreg = split;
		@inreg = split(/\(/, $tempreg[0]);
		chop $inreg[1];
		chop $inreg[1];
		$regn = hex $inreg[1];

		$_ = <IN_FILE>;
		@tempreg = split();
		$reg_val{$regn} = hex $tempreg[1];
	}

	if (/OUTREG/)
	{
		@tempreg = split;
		@outreg = split(/\(/, $tempreg[0]);
		chop $outreg[1];
		$regn = hex $outreg[1];
		chop $tempreg[1];
		chop $tempreg[1];
		print hex $tempreg[1], "\n";
		$newval = hex $tempreg[1];
		if ($reg_val{$regn} && $reg_val{$regn} != $newval) {
			print sprintf("OX: %08X - from %08X to %08X\n", $regn, $reg_val{$regn}, $newval), "\n";
			$reg_val{$regn} = $newval;
		}
		$count = 0;
		while ($count < $num_regs)
		{
			if ($reg_num[$count] == $regn)
			{
				print $reg_name[$count], " ", $_;
			}
			$count++;
		}
		
	}


}


close IN_FILE;

while ( ($k,$v) = each %reg_val ) {
    print sprintf("%08X => %08X",$k, $v), "\n";
}
